# opentl::math::Vector4 Class Reference

special class for vectors with dimension of four More...

Inherits opentl::math::Vector.

List of all members.

## Public Member Functions
double | abs () const
| calculates the length of this vector
double | calcStdDeviation () const
| caclulates the standard deviation of this vector
Vector4 | crossProduct (const math::Vector4 &v2)
| Calculate 3D cross product of two homogeneous vectors this, v2.
std::size_t | dimension () const
| get the dimension of this vector (2)
double | dotProduct (const Vector *v2) const
| caclulates the dot product of this vector and another
void | normalize ()
| normailize this vector
| Vector4 (const Vector3 &v)
| Constructor based on a three dimensional vector.
| Vector4 (const Matrix &m)
| Vector4 (const Vector4 &m)
| Constructor based on an existing matrix.
| Vector4 (double x, double y, double z, double s=1.0f)
| Constructor taking vector data and set fourth dimension to 1.0.
| Vector4 ()
| Constructor.
virtual | ~Vector4 ()
| Destructor.

## Detailed Description

special class for vectors with dimension of four

Author:
  Claus Lenz <lenz@in.tum.de>

  Thomas Friedlhuber <friedlhu@in.tum.de>

  Thorsten Roeder <roeder@in.tum.de>

## Constructor & Destructor Documentation

opentl::math::Vector4::Vector4 | ( |  | ) |

Constructor.

virtual opentl::math::Vector4::~Vector4 | ( |  | ) | `[virtual]`

Destructor.

opentl::math::Vector4::Vector4 | ( | double | x,
|  | double | y,
|  | double | z,
|  | double | s = `1.0f` |
| ) |  |  |

Constructor taking vector data and set fourth dimension to 1.0.

Parameters:

  | x | vector element 0
  | y | vector element 1
  | z | vector element 2
  | s | vector element 3, scale parameter (default = 1.0)

opentl::math::Vector4::Vector4 | ( | const Vector4 & | m | ) |

Constructor based on an existing matrix.

Parameters:

  | m | existing matrix

opentl::math::Vector4::Vector4 | ( | const Matrix & | m | ) | `[explicit]`

opentl::math::Vector4::Vector4 | ( | const Vector3 & | v | ) | `[explicit]`

Constructor based on a three dimensional vector.

Parameters:

  | v | existing vector

## Member Function Documentation

double opentl::math::Vector4::abs | ( |  | ) | const

calculates the length of this vector

Returns:
  length

double opentl::math::Vector4::calcStdDeviation | ( |  | ) | const

caclulates the standard deviation of this vector

Returns:
  standard deviation

Vector4 opentl::math::Vector4::crossProduct | ( | const math::Vector4 & | v2 | ) |

Calculate 3D cross product of two homogeneous vectors this, v2.

Parameters:

  | v2 | second vector of cross product

Returns:
  Vector4 result

std::size_t opentl::math::Vector4::dimension | ( |  | ) | const`[virtual]`

get the dimension of this vector (2)

Returns:
  dimension (=4)

Reimplemented from opentl::math::Vector.

double opentl::math::Vector4::dotProduct | ( | const Vector * | v2 | ) | const

caclulates the dot product of this vector and another

Parameters:

  | v2 | the 2nd vector to be used

Returns:
  dot product

void opentl::math::Vector4::normalize | ( |  | ) | `[virtual]`

normailize this vector

Reimplemented from opentl::math::Vector.